#include <stdio.h>
#include <sql.h>
#include <sqlext.h>
#include <pthread.h>

#define    CHUNKSIZE       65536


void *get_blob (SQLHDBC dbc)
{

   SQLHSTMT stmt;
   SQLRETURN ret; /* ODBC API return status */
   SQLCHAR table[ 64 ];
	 
   /* Allocate a statement handle */
   SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);
   
   printf("SQLExecDirect\n");
   ret = SQLExecDirect(stmt, "SELECT * FROM tblvoicemessages WHERE dir='/var/spool/asterisk/voicemail/K0001/6669/busy' AND msgnum='-1'", SQL_NTS);
   printf("after SQLExecDirect\n");
   
   if (ret == SQL_SUCCESS) {
   printf("SQL_SUCCESS\n");
      ret = SQLFetch(stmt);
	  printf("SQLFetch\n");
      if (ret == SQL_ERROR || ret == SQL_SUCCESS_WITH_INFO) {
         printf("error1: %d\n", ret);
      }
      if (ret == SQL_SUCCESS || ret == SQL_SUCCESS_WITH_INFO){
	     printf( "Start SQLGetData\n");
         ret = SQLGetData(stmt, 0, SQL_BINARY, table, CHUNKSIZE, NULL);
		 SQLFreeHandle (SQL_HANDLE_STMT, stmt);
	  } else
	     printf("error2 %d\n", ret);

	} else 
       printf("error3: %d\n", ret);
	   
  return NULL;
}

main() {

   SQLHENV env;
   SQLHDBC dbc;
   SQLHSTMT stmt;
   SQLRETURN ret; /* ODBC API return status */
   SQLSMALLINT columns; /* number of columns in result-set */
   SQLCHAR table[ 64 ];
   SQLCHAR column[ 64 ];
   long type;
   SQLLEN indicator[ 3 ];
   int i;
   
   /* Allocate an environment handle */
   SQLAllocHandle(SQL_HANDLE_ENV, SQL_NULL_HANDLE, &env);

   /* We want ODBC 3 support */
   SQLSetEnvAttr(env, SQL_ATTR_ODBC_VERSION, (void *) SQL_OV_ODBC3, 0);

   /* Allocate a connection handle */
   SQLAllocHandle(SQL_HANDLE_DBC, env, &dbc);

   /* Connect to the DSN mydsn */
   /* You will need to change mydsn to one you have created and tested */
   SQLDriverConnect(dbc, NULL, "DSN=asteriskWrite;", SQL_NTS,
                 NULL, 0, NULL, SQL_DRIVER_COMPLETE);
   
   pthread_t p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15,
			p16, p17, p18, p19, p20;
  
  printf( "Start 1\n");
  pthread_create (&p1, NULL, get_blob, dbc);
  printf( "Start 2\n");
  pthread_create (&p2, NULL, get_blob, dbc);
  printf( "Start 3\n");
  pthread_create (&p3, NULL, get_blob, dbc);
  printf( "Start 4\n");
  pthread_create (&p4, NULL, get_blob, dbc);
  printf( "Start 5\n");
  pthread_create (&p5, NULL, get_blob, dbc);
  printf( "Start 6...\n");
  pthread_create (&p6, NULL, get_blob, dbc);
  pthread_create (&p7, NULL, get_blob, dbc);
  pthread_create (&p8, NULL, get_blob, dbc);
  pthread_create (&p9, NULL, get_blob, dbc);
  pthread_create (&p10, NULL, get_blob, dbc);
  pthread_create (&p11, NULL, get_blob, dbc);
  pthread_create (&p12, NULL, get_blob, dbc);
  pthread_create (&p13, NULL, get_blob, dbc);
  pthread_create (&p14, NULL, get_blob, dbc);
  pthread_create (&p15, NULL, get_blob, dbc);
  pthread_create (&p16, NULL, get_blob, dbc);
  pthread_create (&p17, NULL, get_blob, dbc);
  pthread_create (&p18, NULL, get_blob, dbc);
  pthread_create (&p19, NULL, get_blob, dbc);
  pthread_create (&p20, NULL, get_blob, dbc);
  
  //pthread_join (p1, NULL);0


  printf ("20 threads startet\n");
 
  getchar();
 
}

